#!/bin/bash
set -x

# see man flock "EXAMPLES"
[ "${FLOCKER}" != "$0" ] && exec env FLOCKER="$0" flock -enF "$0" "$0" "$@" || :

HOST={{ rsync.host | quote }}
USER={{ rsync.user | quote }}

{% if node_exporter_textfile_dir is defined %}
PROMFILE={{ (node_exporter_textfile_dir + '/' + rsync_pull_script_prefix + rsync.name + '.prom') | quote }}
METRIC_RSYNC_EXIT="{{ rsync_pull_metrics_prefix }}_rsync_exit_status"
METRIC_RSYNC_START="{{ rsync_pull_metrics_prefix }}_rsync_start_timestamp"
METRIC_RSYNC_END="{{ rsync_pull_metrics_prefix }}_rsync_end_timestamp"
METRIC_DST_SIZE="{{ rsync_pull_metrics_prefix }}_dst_size_bytes"
cat <<EOF > "$PROMFILE.$$"
# HELP ${METRIC_DST_SIZE} size of destination directory after rsync in bytes
# TYPE ${METRIC_DST_SIZE} gauge
# HELP ${METRIC_RSYNC_EXIT} exit status of rsync process
# TYPE ${METRIC_RSYNC_EXIT} gauge
# HELP ${METRIC_RSYNC_START} rsync start timestamp
# TYPE ${METRIC_RSYNC_START} gauge
# HELP ${METRIC_RSYNC_END} rsync start timestamp
# TYPE ${METRIC_RSYNC_END} gauge
EOF
{% endif %}

{% for fetch in rsync.fetch %}
if {{ (fetch.disabled is defined and fetch.disabled) | ternary('false','true') }} ; then
    SRC={{ fetch.src | quote }}
    DST={{ fetch.dst | quote }}

    mkdir -p "$DST"

    RSYNC_START=`date +%s.%N`
    rsync -avz \
{% if fetch.delete is defined and fetch.delete %}
        --delete \
{% endif %}
{% if rsync.ssh_key_path is defined and rsync.ssh_key_path %}
        -e "ssh -i {{ rsync.ssh_key_path | quote }}" \
{% endif %}
        "${USER}@${HOST}:${SRC}/" "$DST/"
    RSYNC_EXIT="$?"
    RSYNC_END=`date +%s.%N`
{% if node_exporter_textfile_dir is defined %}
    LABELS="{name=\"{{ rsync.name }}\",fetch_name=\"{{ fetch.name }}\"}"

    DST_SIZE_BYTES=`du -sb "$DST" | cut -f1`
    test -n "$DST_SIZE_BYTES" || DST_SIZE_BYTES="0"

    cat <<EOF >> "$PROMFILE.$$"
${METRIC_DST_SIZE}${LABELS} $DST_SIZE_BYTES
${METRIC_RSYNC_EXIT}${LABELS} $RSYNC_EXIT
${METRIC_RSYNC_START}${LABELS} $RSYNC_START
${METRIC_RSYNC_END}${LABELS} $RSYNC_END
EOF
{% endif %}
fi
{% endfor %}

{% if node_exporter_textfile_dir is defined %}
mv -f "$PROMFILE.$$" "$PROMFILE"
{% endif %}
